/*  Copyright (C) 2014 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file AnnotationReader.h
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 24.04.2014
 *  Declaraion of parameter class AnnotationReader.
 */
#ifndef _ANNOTATIONREADER_H_
#define _ANNOTATIONREADER_H_

#ifdef _MSC_VER
#ifdef annotationreader_EXPORTS
/// Visual C++ specific code
#define annotationreader_DECLDIR __declspec(dllexport)
#else
#define annotationreader_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define annotationreader_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/CImg.h>
#include "SuperEasyJSON/json.h"
#include <charon-utils/Annotation.hxx>

/// Reads JSON box values
/** Reads JSON box values
 */
class annotationreader_DECLDIR AnnotationReader : public ParameteredObject {
public:
	/// default constructor
	/// \param name             instance name
	AnnotationReader(const std::string& name = "");

	/// JSON file
	Parameter< std::string > jsonFile;

	/// vebose
	Parameter< bool > verbose;

	/// vebose
	Parameter< int > maxObjects;

	/// values from json file
	OutputSlot< annotation::AnnotationList > annotations;


protected:
	/// Update object.
	virtual void execute();
};

#endif /* _ANNOTATIONREADER_H_ */
