/*  Copyright (C) 2014 Moritz Becker

	This file is part of Charon.

	Charon is free software: you can redistribute it and/or modify
	it under the terms of the GNU Lesser General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Charon is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU Lesser General Public License for more details.

	You should have received a copy of the GNU Lesser General Public License
	along with Charon.  If not, see <http://www.gnu.org/licenses/>.
*/
/** \file AnnotationWriter.h
 *  \author <a href="mailto:moritz.becker@iwr.uni-heidelberg.de">
 *      Moritz Becker</a>
 *  \date 21.05.2014
 *  Declaraion of parameter class AnnotationWriter.
 */
#ifndef _ANNOTATIONWRITER_H_
#define _ANNOTATIONWRITER_H_

#ifdef _MSC_VER
#ifdef annotationwriter_EXPORTS
/// Visual C++ specific code
#define annotationwriter_DECLDIR __declspec(dllexport)
#else
#define annotationwriter_DECLDIR __declspec(dllimport)
#endif /*Export or import*/
#else
/// Not needed without MSVC
#define annotationwriter_DECLDIR
#endif

#include <charon-core/ParameteredObject.h>
#include <charon-utils/Annotation.hxx>

/// Writes annotation objects back to a JSON file
/** Writes annotation objects back to a JSON file
 */
class annotationwriter_DECLDIR AnnotationWriter : public ParameteredObject {
public:
	/// default constructor
	/// \param name             instance name
	AnnotationWriter(const std::string& name = "");

	/// AnnotationList Object
	InputSlot< annotation::AnnotationList > annotation;

	/// File path to new JSON file
	Parameter< std::string > jsonFile;


protected:
	/// Update object.
	virtual void execute();
};

#endif /* _ANNOTATIONWRITER_H_ */
